#APP_NAME="FLOPPYmate"
#APP_VERSION="Version 3.00"
#APP_BY="by Yorck Thiele"
#APP_BUILT=#PB_Compiler_Date
#FILE_ERROR_R="Error: Can't read from file "
#FILE_ERROR_W="Error: Can't write to file "
#EXCLUDED_1581="NOT APPLICABLE TO 1581"
#PWR_ON_MSG="SER2IEC V2.0"
#InBufSize=40000
#OutBufSize=12000
#TrackBufSize=12000
#IMAGEMAX=$C8000  ;820KB
#BytesSectorPayload=254
#SLOW=0
#FAST=1
#CBM1541=0
#CBM1570=1
#CBM1571=2
#CBM1581=3
#CBMXXXX=4
#PROGRESS_FIELD=1
#START_DEVICE=8
#END_DEVICE=11
#MAXCOMPORTS=32
#MAXTRACK=80 ;1581 rules here
#READRETRIES=10
#T_FAST_CLK=3 ;FAST CLK period in us (min 2us)
#SPIN_TIME=200000;[us] 300RPM -> 200ms
#ATMEGA_CLK=14.7456;[MHz]
#ATMEGA_PRESCALER=8
#TIMER1MAX=$10000
#TIMEOUT=#TIMER1MAX/#ATMEGA_CLK*#ATMEGA_PRESCALER ;[us]
#HEADER_ID=$08
#DATA_BLOCK_ID=$07

;error level
#ERR_IEC=1
#ERR_ATMEGA=2
#ERR_CANCEL=4

;menu

; #FASTFORMAT=21
; #RPMCHECK=22

;Utility
#INIT=0
#M_R=1
#M_W=2
#M_M=3
#M_E=4
#T_R=5
#T_W=6
#RPM=7
#RMB=8

#READ_TRACK=0
#WRITE_TRACK=1
#READ_MEMORY=2
#MEASURE_RPM=3


Structure TrInfo
  Sectors.a
  Offset.l
  Capacity.l
  ReadCapacity.l
  BitRate.a
  HeaderID.a
  DataBlockID.a
  DataBlockSyncN.a
  HeaderFill1.a
  HeaderFill2.a
  HeaderGap.a
  HeaderGapN.a
  HeaderSyncN.a
  InterSectorGap.a
  InterSectorGapN.a
  TailGap.a
  FormatLayout.a
EndStructure

Global Dim TrackPar.TrInfo(#MAXTRACK) ;parameters for specific track
Global Dim SerBuffer.a(#InBufSize)
Global Dim Message.a(#OutBufSize)
Global Dim TrackBuffer.a(#TrackBufSize)
Global Dim DiskImage.a(#IMAGEMAX)       
Global Dim Temp.a(1)
Global Dim TrackInfo(3)
Global Dim GCR2Bin.a(32)
Global Dim Bin2GCR.a(16)
Global Dim DiskID.a(2)

Global DOS_Error.a
Global DOS_ErrNum.a
Global ErrorLevel.a
Global SerBufPointer
Global TrackBufPointer
Global Cancel.a
Global IEC_Status.a
Global DeviceErr.a
Global Device.a
Global DeviceSerialMode.a
Global DeviceSerial_6522_Mode.a
Global DiskType.a
Global DriveTypeNum.a
Global DriveType.s
Global Download.a
Global ConsoleMode.a
Global TracksOnDisk.a
Global CylindersOnDisk.a
Global OnlySide0.a=#False
Global SectorCount.l
Global ActualDriveSpintime.l=#SPIN_TIME ;[us]
Global ImageErrorBytes.a
Global ImageErrorStart.l
Global ImageSize.l


Global Window_0, Frame3D_0, Button_0, Combo_0, ListView_0, Editor_0, Splitter_0, Panel_0, Panel_1, Editor_1

Enumeration #PB_Compiler_EnumerationValue
  #Font_0
  #Font_1
  #Font_2
  #Font_3
  #FASTFORMAT=21
  #RPMCHECK
  #DUMPROM
  #MENU_FASTFORMAT
  #MENU_RPM_CHECK
  #MENU_RPM_ADJUST
  #MENU_DUMP_ROM
  #MENU_ABOUT
  #MENU_QUIT
  #MENU_ERROR_INFO
  #MENU_DIRECTORY
  #MENU_CREATE_IMAGE
  #MENU_RESTORE_IMAGE
  #MENU_VERIFY_IMAGE
  #MENU_SEND_DOS_COMMAND
  #MENU_CONSOLE
  #MENU_DUMP_TRACK
  #MENU_CONVERT_GCR
  #MENU_CONVERT_HEX
  #MENU_ENABLE_40TRACKS
  #MENU_ENABLE_ERRORS
EndEnumeration

LoadFont(#Font_0,"Microsoft Sans Serif", 12)
LoadFont(#Font_1,"Consolas", 12,#PB_Font_Bold)
LoadFont(#Font_2,"Consolas", 10)

DataSection
  GCR_table:    
  Data.a 0,0,0,0,0,0,0,0,0,8,0,1,0,$c,4,5
  Data.a 0,0,2,3,0,$F,6,7,0,9,$a,$b,0,$d,$e,0
  GCR_table1:    
  Data.a $a,$b,$12,$13,$e,$f,$16,$17,9,$19,$1a,$1b,$d,$1d,$1e,$15
  floppy_img:
  IncludeBinary "floppy.png"
EndDataSection

  #tbwidth=90
  #tbheight=30
  #parentwidth=650
  #parentheight=600
  #frame0h=60

Procedure InitWindow_0()

  Window_0 = OpenWindow(#PB_Any, 0, 0, #parentwidth, #parentheight, #APP_NAME, #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
  If CreateMenu(0, WindowID(Window_0))
    MenuTitle("File")
    MenuItem(#MENU_RESTORE_IMAGE, "Restore disk image")
    MenuItem(#MENU_CREATE_IMAGE, "Create disk image")
    MenuItem(#MENU_VERIFY_IMAGE, "Verify disk image")
    MenuBar()
    MenuItem(#MENU_QUIT, "Quit")
    
    MenuTitle("Disk")
    MenuBar()
    MenuItem(#MENU_ENABLE_40TRACKS,"Enable 40 tracks")
    MenuItem(#MENU_ENABLE_ERRORS,"Enable image errors")
    MenuBar()
    MenuItem(#MENU_FASTFORMAT, "Fast Format")
    MenuItem(#MENU_SEND_DOS_COMMAND, "DOS command")

    
    MenuTitle("Tools")
    MenuItem( #MENU_RPM_CHECK, "RPM check")
    MenuItem( #MENU_RPM_ADJUST, "RPM adjust")
    MenuItem(#MENU_DUMP_TRACK, "Dump track")
    MenuItem(#MENU_DUMP_ROM, "Dump ROM")
    MenuBar()
    MenuItem(#MENU_CONVERT_GCR, "GCR -> HEX")
    MenuItem(#MENU_CONVERT_HEX, "HEX -> GCR")
    
    MenuTitle("Info")
    MenuItem(#MENU_ERROR_INFO, "Error info")
    MenuBar()
    MenuItem(#MENU_ABOUT, "About")
  EndIf
  CreateToolBar(0, WindowID(Window_0),#PB_ToolBar_Text | #PB_ToolBar_Large) 
  UsePNGImageDecoder()
  
  CatchImage(1, ?floppy_img)
  ToolBarImageButton(#MENU_DIRECTORY, ImageID(1),#PB_ToolBar_Toggle,"LOAD "+Chr(34)+"$"+Chr(34))
  ToolBarToolTip(0,#MENU_DIRECTORY,"Directory ")
  ToolBarSeparator()
  ToolBarImageButton(#MENU_CREATE_IMAGE, ImageID(1),#PB_ToolBar_Toggle,"  Create  ")
  ToolBarToolTip(0,#MENU_CREATE_IMAGE,"Create Disk Image")
  ToolBarSeparator()
  ToolBarImageButton(#MENU_RESTORE_IMAGE, ImageID(1),#PB_ToolBar_Toggle,"  Restore ")
  ToolBarToolTip(0,#MENU_RESTORE_IMAGE,"Resore Disk Image")
  ToolBarSeparator()
  ToolBarImageButton(#MENU_VERIFY_IMAGE, ImageID(1),#PB_ToolBar_Toggle,"  Verify  ")
  ToolBarToolTip(0,#MENU_VERIFY_IMAGE,"Verify Disk <-> Image")
  ToolBarSeparator()
  ToolBarImageButton(#MENU_SEND_DOS_COMMAND, ImageID(1),#PB_ToolBar_Toggle,"    CMD   ")
  ToolBarToolTip(0,#MENU_SEND_DOS_COMMAND,"Send DOS Command")
  
  CreateStatusBar(0, WindowID(Window_0))
  AddStatusBarField(400)
  AddStatusBarField(150)
  StatusBarProgress(0, #PROGRESS_FIELD, 0)

  tb0h=ToolBarHeight(0)
  sb0h=StatusBarHeight(0)
  Frame3D_0 = FrameGadget(#PB_Any, 5, tb0h+5, #parentwidth-10, #frame0h, "Device")
  Combo_0 = ComboBoxGadget(#PB_Any, 30, tb0h+25, 160, 30);Device
  Button_0 = ButtonGadget(#PB_Any, 240, tb0h+25, 110, 30, "RESET", #PB_Button_Toggle)
  SetGadgetFont(Combo_0, FontID(#Font_0))
  ListView_0 = ListViewGadget(#PB_Any, 0, 0, 0, 0)
  SetGadgetColor(ListView_0, #PB_Gadget_FrontColor,RGB(128,128,255))
  SetGadgetColor(ListView_0, #PB_Gadget_BackColor,RGB(0,0,255))
  SetGadgetFont(ListView_0, FontID(#Font_1))
  Editor_0 = EditorGadget(#PB_Any, 0, 0, 0, 0, #PB_Editor_ReadOnly)
  SetGadgetFont(Editor_0, FontID(#Font_2))
  Panel_0=PanelGadget(#PB_Any, 5, tb0h+#frame0h+10, #parentwidth-10, #parentheight-#frame0h-tb0h-sb0h-40)
  AddGadgetItem (Panel_0, -1, "Output")
  
  Splitter_0=SplitterGadget(#PB_Any,0,0,GetGadgetAttribute(Panel_0,#PB_Panel_ItemWidth),GetGadgetAttribute(Panel_0,#PB_Panel_ItemHeight),ListView_0,Editor_0, #PB_Splitter_Separator)
  AddGadgetItem (Panel_0, -1,"Track GCR")
  Editor_1 = EditorGadget(#PB_Any,0,0,GetGadgetAttribute(Panel_0,#PB_Panel_ItemWidth),GetGadgetAttribute(Panel_0,#PB_Panel_ItemHeight), #PB_Editor_ReadOnly)
  SetGadgetFont(Editor_1, FontID(#Font_2))
  CloseGadgetList()

EndProcedure

Procedure.l CalcTrackCapacity(bitrate_zone, rpm.f=300)
  
 ;calculates track capacity in bytes --> bitrate/8bit * 60s/300RPM (nominal)
ProcedureReturn Int(Round(16e6/4/(16-bitrate_zone)/8*60/rpm,#PB_Round_Down))

EndProcedure


Procedure SetTrackParameter()
;get 1541/157x/ specific bit rate per track
; * for Tracks 36-70: calculate Track-35 	(applies to 1571 only)  

  For Track=1 To #MAXTRACK
    Select DriveTypeNum
      Case #CBM1581
        TrackPar(Track)\Offset=(Track - 1) * 40 * 256
        TrackPar(Track)\Sectors=40
      Default
        If OnlySide0=#False And Track>35
          physical_track=Track-35
          DoubleSided=1
        Else
          physical_track=Track 
        EndIf
        Select physical_track
          Case 1 To 17
            TrackPar(Track)\Offset=DoubleSided * $2AB00 + (physical_track - 1) * 21 * 256
            TrackPar(Track)\Sectors=21
            TrackPar(Track)\Capacity= CalcTrackCapacity(3) ;7693 bytes
            TrackPar(Track)\ReadCapacity=32 ;ReadCapacity x 256 bytes
            TrackPar(Track)\BitRate=Val("%1100000")  ;bitrate=307692
            TrackPar(Track)\InterSectorGapN=4        ;gap x $55 byte
          Case 18 To 24
            TrackPar(Track)\Offset=DoubleSided * $2AB00 + (physical_track - 18) * 19 * 256 + $16500
            TrackPar(Track)\Sectors=19
            TrackPar(Track)\Capacity= CalcTrackCapacity(2) ;7143 bytes
            TrackPar(Track)\ReadCapacity=30 ;ReadCapacity x 256 bytes
            TrackPar(Track)\BitRate=Val("%1000000") ;bitrate=285714
            TrackPar(Track)\InterSectorGapN=14      ;gap x $55 byte
          Case 25 To 30
            TrackPar(Track)\Offset=DoubleSided * $2AB00 + (physical_track - 25) * 18 * 256 + $1EA00
            TrackPar(Track)\Sectors=18
            TrackPar(Track)\Capacity= CalcTrackCapacity(1) ;6667 bytes
            TrackPar(Track)\ReadCapacity=28;ReadCapacity x 256 bytes
            TrackPar(Track)\BitRate=Val("%0100000") ;bitrate=266667
            TrackPar(Track)\InterSectorGapN=9       ;gap x $55 byte
          Case 31 To 70                             ;only max. 41 for practical use
            TrackPar(Track)\Offset=DoubleSided * $2AB00 + (physical_track - 31) * 17 * 256 + $25600
            TrackPar(Track)\Sectors=17
            TrackPar(Track)\Capacity= CalcTrackCapacity(0)  ;6250 bytes
            TrackPar(Track)\ReadCapacity=27;ReadCapacity x 256 bytes
            TrackPar(Track)\BitRate=Val("%0000000") ;bitrate= 250000
            TrackPar(Track)\InterSectorGapN=6       ;gap x $55 byte
        EndSelect
        TrackPar(Track)\DataBlockID=#DATA_BLOCK_ID
        TrackPar(Track)\HeaderID=#HEADER_ID
        TrackPar(Track)\HeaderFill1=$0F
        TrackPar(Track)\HeaderFill2=$0F
        TrackPar(Track)\HeaderGapN=9 ;N times the Header Gap byte
        TrackPar(Track)\HeaderGap=$55 ;Gap byte, GCR coded
        TrackPar(Track)\InterSectorGap=$55 ;GCR coded
        TrackPar(Track)\TailGap=$55        ;GCR coded
        TrackPar(Track)\HeaderSyncN=5 ;N times the Sync byte $FF 
        TrackPar(Track)\DataBlockSyncN=5
        TrackPar(Track)\FormatLayout='A' ;1541/157x/4040 format layout designator
    EndSelect
  Next Track

EndProcedure

Procedure.a GetMaxTrackByDriveType(ignore_disk_type=#False)
  
  FillMemory(@DiskImage(),#IMAGEMAX) ;clear
  If OnlySide0=#False
    Select DriveTypeNum
      Case #CBM1571
        If DiskType = #CBM1571 Or ignore_disk_type=#True
          If ImageErrorBytes=#True
            ImageSize=2*$2AB00+$556     ;342KB 70 tracks, 1366 error bytes
            ImageErrorStart=2*$2AB00
          Else
            ImageSize=2 * $2AB00         ;341KB:  70 tracks, no error bytes
          EndIf
          CylindersOnDisk= 35
          TracksOnDisk=  70         ;physical 35 cylinders -> logical 70 tracks
        Else
          If ImageErrorBytes=#True
            ImageSize=$2ADAB            ;170KB: 35 tracks, 683 error bytes
            ImageErrorStart=$2AB00
          Else
            ImageSize=$2AB00            ;170KB:  35 tracks, no error bytes
          EndIf
          CylindersOnDisk= 35
          TracksOnDisk=  35
        EndIf
      Case #CBM1581
        ImageSize=$C8000            ;820KB
        CylindersOnDisk= 80
        TracksOnDisk=  80
      Default
        If ImageErrorBytes=#True
          ImageSize=$2ADAB        ;170KB: 35 tracks, 683 error bytes
          ImageErrorStart=$2AB00
        Else
          ImageSize=$2AB00         ;170KB:  35 tracks, no error bytes
        EndIf
        CylindersOnDisk= 35
        TracksOnDisk=  35
    EndSelect
  Else
    Select DriveTypeNum
      Case #CBM1541,#CBM1570,#CBM1571
        If ImageErrorBytes=#True
          ImageSize=$30300        ;192KB: 40 tracks, 768 error bytes
          ImageErrorStart=$30000
        Else
          ImageSize=$30000        ;192KB: 40 tracks, no error bytes
        EndIf
        CylindersOnDisk= 40
        TracksOnDisk=  40
    EndSelect
  EndIf
  SetTrackParameter()
  ProcedureReturn TracksOnDisk
  
EndProcedure

Procedure.a GetMaxTrackByFileLen(Flen.l)
  
  OnlySide0=#False
  FileLenValid=#False
  ImageErrorBytes=#False
  Select DriveTypeNum
    Case #CBM1541, #CBM1570, #CBM1571
      Select Flen
        Case $2AB00 ;170KB: 35 tracks, no error bytes
          FileLenValid=#True
          DiskType = #CBM1541
        Case $2ADAB ;170KB: 35 tracks, 683 error bytes
          FileLenValid=#True
          ImageErrorBytes=#True
          DiskType = #CBM1541         
        Case $30000 ;192KB 40 tracks, no error bytes
          OnlySide0=#True
          FileLenValid=#True
        Case $30300 ;192KB: 40 tracks, 768 error bytes
          OnlySide0=#True
          ImageErrorBytes=#True
          FileLenValid=#True          
        Case 2*$2AB00 ;341KB 70 tracks, no error bytes
          If DriveTypeNum=#CBM1571
            FileLenValid=#True
          EndIf
        Case 2*$2AB00+$556 ;342KB 70 tracks, 1366 error bytes
          If DriveTypeNum=#CBM1571
            ImageErrorBytes=#True
            FileLenValid=#True
          EndIf          
      EndSelect
    Case #CBM1581
      Select Flen
        Case $C8000 ;820KB
          FileLenValid=#True
      EndSelect  
  EndSelect
  If FileLenValid=#True
    ProcedureReturn GetMaxTrackByDriveType()
  Else
    MessageRequester(#APP_NAME,"File size does not match drive capacity.")
    ProcedureReturn 0
  EndIf
  
EndProcedure

Procedure AppendLogEntry(entry.s, bcolor.l=-1)
  If entry<>"":entry=FormatDate("%hh:%ii:%ss", Date()) + " "+ entry:EndIf
  If ConsoleMode=#True
    PrintN (entry)
  Else  
    AddGadgetItem(Editor_0,-1,entry)
    SendMessage_(GadgetID(Editor_0),#EM_SCROLL,#SB_BOTTOM,0)
  EndIf
  While WindowEvent():Wend
  
EndProcedure

Procedure.l FileSeekTest(filenum.l, newpos.l, silent=#False)

  If newpos>Lof(filenum)
    If Not silent:AppendLogEntry("Error: File access beyond EOF!"):EndIf
    ProcedureReturn #False 
  Else
    FileSeek(filenum,newpos)
    ProcedureReturn #True
  EndIf

EndProcedure

Procedure.s GetStatusTxt(status.a, Get_DOS_StatusTxt=#False)
  
  If Get_DOS_StatusTxt=#False
    IECErrTxt.s = "OK"
    Select  status
      Case 2
        IECErrTxt = "TIMEOUT (IEC IN)"
      Case 3
        IECErrTxt = "TIMEOUT (IEC OUT)"
      Case 8
        IECErrTxt = "TIMEOUT (READ TRACK)"
      Case 32 ;OK, FAST DEVICE (set only when using OPEN)
      Case 64 ;EOI
      Case 66 ;corrupt disk (not fatal)
      Case 128,4,255
        IECErrTxt = "DEVICE NOT PRESENT"
    EndSelect
    
    ProcedureReturn IECErrTxt
  Else
    ;      BIT 7       6       5       4       3       2       1       0
    ;============================================================================
    ;      MODE        DN     SECTOR SIZE      [  CONTROLLER  STATUS   ]
   ;;----------------------------------------------------------------------------
    ;
    ; Values Represented are in Binary
    ;
    ;   MODE - 1571: 1=MFM, 0=GCR
    ;          1581: 1=Alien Disk Format, 0=Resident Disk Format (MFM)
    ;     DN - DRIVE NUMBER
    ;
    ; SECTOR SIZE - (MFM ONLY)
    ;          00 .... 128 BYTE SECTORS
    ;          01 .... 256 BYTE SECTORS
    ;          10 .... 512 BYTE SECTORS
    ;          11 .... 1024 BYTE SECTORS
    ;
    ; CONTROLLER STATUS (GCR)
    ;        000X .... OK
    ;        0010 .... SECTOR NOT FOUND
    ;        0011 .... NO SYNC
    ;        0100 .... DATA BLOCK NOT FOUND
    ;        0101 .... DATA BLOCK CHECKSUM ERROR
    ;        0110 .... FORMAT ERROR
    ;        0111 .... VERIFY ERROR
    ;        1000 .... WRITE PROTECT ERROR
    ;        1001 .... HEADER BLOCK CHECKSUM ERROR
    ;        1010 .... DATA EXTENDS INTO NEXT BLOCK
    ;        1011 .... DISK ID MISMATCH/DISK CHANGE
    ;        1100 .... RESERVED
    ;        1101 .... RESERVED
    ;        1110 .... SYNTAX ERROR
    ;        1111 .... NO DISK PRESENT
    ;
    ; CONTROLLER STATUS (MFM)
    ;        000X .... OK
    ;        0010 .... SECTOR NOT FOUND
    ;        0011 .... NO ADDRESS MARK
    ;        0100 .... DATA BLOCK NOT PRESENT
    ;        0101 .... DATA CRC ERROR
    ;        0110 .... FORMAT ERROR
    ;        0111 .... VERIFY ERROR
    ;        1000 .... WRITE PROTECT ERROR
    ;        1001 .... HEADER BLOCK CRC ERROR
    ;        1010 .... RESERVED
    ;        1011 .... DISK CHANGE
    ;        1100 .... DISK FORMAT NOT LOGICAL
    ;        1101 .... CONTROLLER ERROR
    ;        1110 .... SYNTAX ERROR
    ;        1111 .... NO DRIVE PRESENT
    
    DOSErrTxt.s="OK"
    
    Select DriveTypeNum
      Case #CBM1581
        If (status & $80)<>0 
          DOSErrTxt = "ALIEN DISK FORMAT"
        Else
          status=status & $f
          Select status
            Case 2
              DOSErrTxt = "SECTOR NOT FOUND"
            Case 3
              DOSErrTxt = "NO ADDRESS MARK"
            Case 4
              DOSErrTxt = "DATA BLOCK NOT PRESENT"
            Case 5
              DOSErrTxt = "DATA CRC ERROR"
            Case 6
              DOSErrTxt = "FORMAT ERROR"
            Case 7
              DOSErrTxt = "VERIFY ERROR"
            Case 8
              DOSErrTxt = "WRITE PROTECT ERROR"
            Case 9
              DOSErrTxt = "HEADER BLOCK CRC ERROR"
            Case 11
              DOSErrTxt = "DISK CHANGE"
            Case 12
              DOSErrTxt = "DISK FORMAT NOT LOGICAL"
            Case 13
              DOSErrTxt = "CONTROLLER ERROR"
            Case 14
              DOSErrTxt = "SYNTAX ERROR"
            Case 15
              DOSErrTxt = "NO DRIVE PRESENT"
          EndSelect   
        EndIf
        
      Default
        If (status & $80)<>0 
          DOSErrTxt = "MFM DISK FORMAT"
        Else
          status=status & $f
          Select status
            Case 2
              DOSErrTxt = "SECTOR NOT FOUND"
            Case 3
              DOSErrTxt = "NO SYNC"
            Case 4
              DOSErrTxt = "DATA BLOCK NOT FOUND"
            Case 5
              DOSErrTxt = "DATA BLOCK CHECKSUM ERROR"
            Case 6
              DOSErrTxt = "FORMAT ERROR"
            Case 7
              DOSErrTxt = "VERIFY ERROR"
            Case 8
              DOSErrTxt = "WRITE PROTECT ERROR"
            Case 9
              DOSErrTxt = "HEADER BLOCK CHECKSUM ERROR"
            Case 10
              DOSErrTxt = "DATA EXTENDS INTO NEXT BLOCK"
            Case 11
              DOSErrTxt = "DISK ID MISMATCH/DISK CHANGE"
            Case 14
              DOSErrTxt = "SYNTAX ERROR"
            Case 15
              DOSErrTxt = "NO DISK PRESENT"
          EndSelect
        EndIf
    EndSelect
    
    ProcedureReturn DOSErrTxt
  EndIf
  
EndProcedure

Procedure EncodeGCR(nbytes)
  
  ;ReDim Temp(nbytes)
  binbytes=0
  
  ;encode 4 BIN to 5 GCR
  ;BIN: 11112222 33334444 55556666 77778888
  ;GCR: 11111222 22333334 44445555 56666677 77788888
  While (binbytes < nbytes) And ((TrackBufPointer+5)<ArraySize(TrackBuffer()))
    bin0=Temp(binbytes+0)
    bin1=Temp(binbytes+1)
    bin2=Temp(binbytes+2)
    bin3=Temp(binbytes+3)
    
    TrackBuffer(TrackBufPointer)=(Bin2GCR(bin0 >> 4)<<3) | (Bin2GCR(bin0 & 15)>>2)
    TrackBuffer(TrackBufPointer+1)=(Bin2GCR(bin0 & 15)<<6) | (Bin2GCR(bin1 >> 4)<<1) | (Bin2GCR(bin1 & 15)>>4)
    TrackBuffer(TrackBufPointer+2)=(Bin2GCR(bin1 & 15)<<4) | (Bin2GCR(bin2 >> 4)>>1)
    TrackBuffer(TrackBufPointer+3)=(Bin2GCR(bin2 >> 4)<<7) | (Bin2GCR(bin2 & 15)<<2) | (Bin2GCR(bin3 >> 4)>>3)
    TrackBuffer(TrackBufPointer+4)=(Bin2GCR(bin3 >> 4)<<5) | Bin2GCR(bin3 & 15)
    
    TrackBufPointer+5
    binbytes+4
  Wend
  
EndProcedure

Procedure.l DecodeGCR(nbytes)
  
  ;nbytes must be a multiple of 4
  Dim Temp(nbytes)
  binbytes=0
  ;decode 5 GCR to 4 BIN
  ;GCR: 11111222 22333334 44445555 56666677 77788888
  ;BIN: 11112222 33334444 55556666 77778888
  

  While (binbytes < nbytes) And ((SerBufPointer+5)<ArraySize(SerBuffer()))
    Temp(binbytes+0)=GCR2Bin(SerBuffer(SerBufPointer) >> 3)<<4  
    Temp(binbytes+0) | GCR2Bin(((SerBuffer(SerBufPointer) << 2) | (SerBuffer(SerBufPointer+1) >> 6)) & Val("%00011111"))
    Temp(binbytes+1)=GCR2Bin((SerBuffer(SerBufPointer+1) >>1) & Val("%00011111"))<<4
    Temp(binbytes+1) | GCR2Bin(((SerBuffer(SerBufPointer+1) << 4) | (SerBuffer(SerBufPointer+2) >> 4)) & Val("%00011111"))
    Temp(binbytes+2)=GCR2Bin(((SerBuffer(SerBufPointer+2) << 1) | (SerBuffer(SerBufPointer+3) >> 7)) & Val("%00011111"))<<4
    Temp(binbytes+2) | GCR2Bin((SerBuffer(SerBufPointer+3) >> 2) & Val("%00011111"))
    Temp(binbytes+3)=GCR2Bin(((SerBuffer(SerBufPointer+3) << 3) | (SerBuffer(SerBufPointer+4) >> 5)) & Val("%00011111"))<<4
    Temp(binbytes+3) | GCR2Bin(SerBuffer(SerBufPointer+4) & Val("%00011111"))
    
    SerBufPointer+5
    binbytes+4
  Wend

  
EndProcedure

Procedure Convert_GCR_HEX()
  
  #MAXVALUES=400
  ReDim SerBuffer(#MAXVALUES)
  SerBufPointer=0:count=0
  FillMemory(@SerBuffer(),#MAXVALUES)
  convert$=Left(InputRequester(#APP_NAME,"Convert GCR to HEX", ""),#MAXVALUES*4)
  
  For n=1 To #MAXVALUES
    gcrvalue$=StringField(convert$,n," ")
    If gcrvalue$<>""
      SerBuffer(count)=Val("$"+gcrvalue$)
      disp$=disp$+RSet(Hex(SerBuffer(count)),2,"0")+" "
      count+1
    EndIf
  Next n
  If count>0
    hexcount=Round(count*4/5,#PB_Round_Up)
    AppendLogEntry("Convert #GCR=$"+Hex(count)+" To #HEX=$"+Hex(hexcount))
    AppendLogEntry("GCR: "+disp$)
    If hexcount %4 <>0
      quadruplets=(hexcount/4)*4+4
    Else
      quadruplets=hexcount
    EndIf
    
    DecodeGCR(quadruplets)
    disp$="":offs=0
    For n=1 To hexcount
      disp$=disp$+RSet(Hex(Temp(n-1)),2,"0")+" "
      If n=hexcount Or n%16 =0
        AppendLogEntry("$"+RSet(Hex(offs),3,"0")+": "+disp$)
        disp$="":offs+16
      EndIf
    Next n
  EndIf
  
EndProcedure

Procedure Convert_HEX_GCR()
  
  #MAXVALUES=400
  ReDim Temp(#MAXVALUES)
  TrackBufPointer=0:count=0
  FillMemory(@Temp(),#MAXVALUES)
  convert$=Left(InputRequester(#APP_NAME,"Convert HEX to GCR", ""),#MAXVALUES*4)
  
  For n=1 To #MAXVALUES
    hexvalue$=StringField(convert$,n," ")
    If hexvalue$<>""
      Temp(count)=Val("$"+hexvalue$)
      disp$=disp$+RSet(Hex(Temp(count)),2,"0")+" "
      count+1
    EndIf
  Next n
  If count>0
    gcrcount=Round(count*5/4,#PB_Round_Up)
    AppendLogEntry("Convert #HEX=$"+Hex(count)+" To #GCR=$"+Hex(gcrcount))
    AppendLogEntry("HEX: "+disp$)
    If count %4 <>0
      quadruplets=(count/4)*4+4
    Else
      quadruplets=count
    EndIf
    EncodeGCR(quadruplets)
    disp$="":offs=0
    For n=1 To gcrcount
      disp$=disp$+RSet(Hex(TrackBuffer(n-1)),2,"0")+" "
      If n=gcrcount Or n%16 =0
        AppendLogEntry("$"+RSet(Hex(offs),3,"0")+": "+disp$)
        disp$="":offs+16
      EndIf
    Next n
  EndIf
  
EndProcedure



Procedure SeekHeader(track.a,sector.a)
  
  SerBufPointer=0
  found=0
  syncfound=#False  
  While SerBufPointer<ArraySize(SerBuffer()) And found<2
    countsync=0
    Repeat
      SerBufPointer=SerBufPointer+1
    Until (SerBuffer(SerBufPointer-1)=$ff And SerBuffer(SerBufPointer)<>$ff) Or SerBufPointer>=ArraySize(SerBuffer())
    
    DecodeGCR(8)
    
   If SerBufPointer<ArraySize(SerBuffer())
      syncfound=#True
      If Temp(0)=TrackPar(Track)\HeaderID ;header?
        found=1
        If Temp(2)=sector And Temp(3)=track
          found=2:chksum.a=0
          For n=1 To 5
            chksum=chksum ! Temp(n)
          Next n
          If chksum=0:found=$FF:EndIf;sector header found, checksum ok?
        EndIf
      EndIf
    Else
      If syncfound=#False:found=$0F:EndIf ;no sync or all sync track
    EndIf
    
  Wend
  
  ProcedureReturn  found
  
  EndProcedure

Procedure.s GetFilenameDialog(SaveAs.a =#False, PatternPos = 0, NameDefault.s="")
  ;uses DriveTypeNum
  
  If Cancel=#True: ProcedureReturn "":EndIf
  
  Static PrevOpenPath.s, PrevSavePath.s
  
  Select SaveAs
    Case #True
      StandardFile.s = PrevSavePath
    Case #False
      StandardFile.s = PrevOpenPath
  EndSelect
  
  If StandardFile.s = "" 
    StandardFile.s=GetCurrentDirectory()
  EndIf
  
  Pattern.s = "D64 Image (*.d64)|*.d64|"
  FileExtension.s="d64"
  
  Select DriveTypeNum
    Case #CBM1571
      If SaveAs = #True
        If DiskType=#CBM1571 And OnlySide0=#False
          Pattern = "D71 Image (*.d71)|*.d71|"
          FileExtension.s="d71"
        EndIf
      Else
        Pattern +  "D71 Image (*.d71)|*.d71|" + "D64 & D71 Image (*.d64;*.d71)|*.d64;*.d71|"
      EndIf
    Case #CBM1581
      Pattern = "D81 Image (*.d81)|*.d81|"
      FileExtension.s="d81"
  EndSelect
  
  Pattern = Pattern + "PRG Image (*.prg)|*.prg|all files (*.*)|*.*"
  Select SaveAs
    Case #True
      Repeat
        File.s = SaveFileRequester("Save as", StandardFile+NameDefault, Pattern, PatternPos)
        If File<>"" And GetExtensionPart(File)=""
          Select SelectedFilePattern()
            Case 0
              File=File+"."+FileExtension
            Case 1
              File=File+".prg"
          EndSelect
        EndIf
        result=#PB_MessageRequester_Yes
        If FileSize(File) <>-1
          Message.s="Replace "+Chr(34)+GetFilePart(File)+Chr(34)+"?"
          result=MessageRequester("File already exists",Message,#PB_MessageRequester_YesNo|$100|$30)
        EndIf 
      Until result=#PB_MessageRequester_Yes 
      If File <> ""
        PrevSavePath=GetPathPart(File)
      Else
        AppendLogEntry ("Save Image canceled")
      EndIf
    Case #False
      File.s = OpenFileRequester("Open", StandardFile, Pattern, PatternPos)
      If File <> ""
        PrevOpenPath=GetPathPart(File)
      EndIf
  EndSelect
  
  ProcedureReturn File
  
EndProcedure


Procedure SendMessage( message_len.l, return_len=16, timout_sec.a=200)
  
  If ErrorLevel>#ERR_IEC:ProcedureReturn:EndIf
  timeout_ms=timout_sec*1000
  SetSerialPortStatus(0,#PB_SerialPort_TXD,1)
  Delay(1)
  SetSerialPortStatus(0,#PB_SerialPort_TXD,0)
  Delay(1)
  While AvailableSerialPortInput(0)<>0
    ReadSerialPortData(0, @SerBuf.s{1}, 1)
  Wend
  WriteSerialPortData (0,@Message(0),message_len)

  While (AvailableSerialPortInput(0)<return_len+4) And ErrorLevel<#ERR_ATMEGA
    If WindowEvent()= #PB_Event_CloseWindow:End:EndIf
    Delay(1)
    timeout_ms=timeout_ms-1
    If ConsoleMode=#True And Inkey()=Chr(27)
        ErrorLevel = #ERR_CANCEL
    EndIf
    If GetGadgetState(Button_0)=1 
      ErrorLevel = #ERR_CANCEL
    ElseIf timeout_ms=0
      AppendLogEntry("Connection Timeout")
      ErrorLevel = #ERR_ATMEGA
    EndIf
  Wend
 
 
  If AvailableSerialPortInput(0)>3 And AvailableSerialPortInput(0)<#InBufSize
   ; Debug "Buffer: "+Str(AvailableSerialPortInput(0))
    ReDim SerBuffer(AvailableSerialPortInput(0))
    
    ReadSerialPortData(0, @SerBuffer(0), AvailableSerialPortInput(0))
    
    If SerBuffer(ArraySize(SerBuffer())-1)=Message(0) ;command echo ok?
      IEC_Status=SerBuffer(ArraySize(SerBuffer())-2)
      ;Debug Str(SerBuffer(0))
      ;Debug Str(IEC_Status)
      payload=SerBuffer(ArraySize(SerBuffer())-4)+256*SerBuffer(ArraySize(SerBuffer())-3)
      ;Debug "Payload: "+Str(payload)
      If payload>0
        ReDim SerBuffer(payload-1)
     ;   Debug "SerBuffer: "+Str(ArraySize(SerBuffer()))
      EndIf
      If GetStatusTxt(IEC_Status)<>"OK" And Device>0 And ErrorLevel=<#ERR_ATMEGA
        AppendLogEntry( "Drive #"+Str(Device)+" ERROR! ---> IEC Bus: "+GetStatusTxt(IEC_Status))
        ErrorLevel | #ERR_IEC
      EndIf
    Else
      AppendLogEntry("Response Error")
    EndIf
  EndIf

ProcedureReturn payload
    
EndProcedure

Procedure IEC_SendString(IEC_Sec_Adr.a, IEC_String.s, open=#False,timeout_sec.a=2)
  
  ; don't use CHR(0) on IEC_String, use CHR($100)!!!
  If (IEC_Sec_Adr=15 Or open=#True) And Len(IEC_String) > 40 
    AppendLogEntry("ERROR - IEC string too long")
  Else
    
    IEC_String=Left(IEC_String,40)
    For n=1 To Len(IEC_String)
      If Asc(Mid(IEC_String,n,1))=$100
        Message(3+n)=0
      Else
        Message(3+n)=Asc(Mid(IEC_String,n,1))
      EndIf
    Next n
    If open=#False
      Message(0)= 3 ;CMD send string
    Else
      Message(0)= 1 ;CMD open
    EndIf
    
    Message(1)= Len(IEC_String)+4
    Message(2)= Device
    Message(3)= IEC_Sec_Adr
    SendMessage(Message(1),16,timeout_sec)
  EndIf

  
EndProcedure

Procedure IEC_SendMessageString(IEC_Sec_Adr.a, IEC_String_Len.a)
 
  Message(0)= 3
  Message(1)= IEC_String_Len+4
  Message(2)= Device
  Message(3)= IEC_Sec_Adr
  SendMessage(Message(1))
  
EndProcedure

Procedure IEC_ReceiveString(IEC_Sec_Adr.a, NBytes.l=64, timout_sec.a=200)
  
  Message(0)= 4
  Message(1)= 6
  Message(2)= Device
  Message(3)= IEC_Sec_Adr
  Message(4)= Int(NBytes / 256)
  Message(5)= NBytes & 255
  ProcedureReturn SendMessage(Message(1),NBytes,timout_sec)

EndProcedure

Procedure IEC_Open(IEC_Sec_Adr.a, IEC_Filename.s)
  
  ErrorLevel =0

  IEC_SendString(IEC_Sec_Adr,IEC_Filename,#True)
  
  If IEC_Status = 32
    IEC_Status = 0
    DeviceSerialMode = #FAST
  Else
    DeviceSerialMode = #SLOW
  EndIf
  
EndProcedure

Procedure IEC_Close(IEC_Sec_Adr.a)
  
  Message(0)= 2
  Message(1)= 4
  Message(2)= Device
  Message(3)= IEC_Sec_Adr
  SendMessage(Message(1))
  
EndProcedure


Procedure File2Message(FName.s, PayloadStart.l)
  MemStart.l=0
  BytesTotal.l=0
  FName=FName+".h65"
  If ReadFile(1, GetCurrentDirectory()+FName)
    While Eof(1) = 0
      bytecount.l=0
      AsmLine.s =  ReadString(1)
      If Len(AsmLine) > 4 
        MemStart = Val("$" + Mid(AsmLine, 1, 4))
        If BytesTotal=0
          ;AppendLogEntry ("Transferring data to Micro")
          StartAdr.l=MemStart
        EndIf
        For i = 0 To 15 ;max 16 hex bytes to read
          AsmLinebyte.s = Mid(AsmLine, 6 + i * 3, 2)
          If AsmLinebyte <> "" 
            Message(PayloadStart+BytesTotal+i)=Val("$" + AsmLinebyte)
            bytecount = bytecount + 1
          EndIf
        Next i
      EndIf
      BytesTotal=BytesTotal+bytecount
    Wend
    ;AppendLogEntry (Hex(StartAdr)+" - "+ Hex(StartAdr+BytesTotal-1)+" --> "+Str(BytesTotal)+" bytes")
    CloseFile(1)
  Else
    MessageRequester(#APP_NAME, #FILE_ERROR_R+FName, 0)
  EndIf  
  ProcedureReturn BytesTotal+PayloadStart
EndProcedure

Procedure.a Utility(param1=0,param2=0,param3=0,param4=0,param5=0)
  
  ;Message(2) holds floppy Utility CMD: floppy $6F
  ;Message(3) holds parameter for CMD: floppy $70
  ;Message(4) holds parameter for CMD: floppy $71
  ;Message(5) holds parameter for CMD: floppy $72
  ;Message(6) holds parameter for CMD: floppy $73
  ;memory CMDs supposed to be included in every utility
  
  If ErrorLevel>0:ProcedureReturn:EndIf
  returnlen=16
  Select param1
    Case 0 ; transfer file data to floppy $300-$3FF and execute $300
      Select DriveTypeNum
        Case #CBM1570,#CBM1571
          fname.s="157x"
        Case #CBM1541
          fname.s="1541"
      EndSelect
      fname+"_U"+Str(param2)
      File2Message(fname,3)
      ;Debug fname
      Message(0)=11
      Message(1)=0
      Message(2)=1 ;one page (256 bytes)
      SendMessage(259) ;transfer data to ATMEGA
      Message(0)= 12
      Message(1)= 4
      Message(2)= Device
      Message(3)= 15  ;IEC_Sec_Adr
      
    Case #M_R ;memory read
      Message(0)= 13 ;ATMEGA CMD
      Message(2)= #M_R-1 ;Utility CMD
      Message(3)= param2 & 255 ;address low
      Message(4)= param2/256   ;address high
      
    Case #M_W ;memory write
      Message(0)= 13 ;ATMEGA CMD
      Message(2)= #M_W-1 ;Utility CMD
      Message(3)= param2 & 255 ;address low
      Message(4)= param2/256   ;address high
      Message(5)= param3       ;data
      
    Case #M_M ;memory modify
      Message(0)= 13 ;ATMEGA CMD
      Message(2)= #M_M-1;Utility CMD
      Message(3)= param2 & 255 ;address low
      Message(4)= param2/256   ;address high
      Message(5)= param3       ;AND mask
      Message(6)= param4       ;OR data
      
    Case #M_E ;memory execute
      Message(0)= 13 ;ATMEGA CMD
      Message(2)= #M_E-1 ;Utility CMD
      Message(3)= param2 & 255 ;address low
      Message(4)= param2/256   ;address high
      
    Case #T_R ;read track
      Message(0)= 14 ;ATMEGA CMD
      Message(2)= #T_R ;Utility CMD
      Message(3)= param2 ;times 256 bytes
      Message(4)= param3 ;track
      Message(5)= param4 ;bit7: 0=logical /1=physical, bit5 & 6: bitrate; bit4: side (157x only) 
      Message(6)= param5 ;<>0 --> wait for sync
      returnlen=param2*256+2
      
    Case #T_W ;write track
      Message(0)= 15 ;ATMEGA CMD
      Message(2)= $81;Utility CMD
      Message(3)= param2 ;write nx256x$55
      Message(4)= param3 ;track
      Message(5)= param4 ;bit7: 0=logical /1=physical, bit5 & 6: bitrate; bit4: side (157x only) 
      
    Case #RPM ;measure RPM
      Message(0)= 16 ;ATMEGA CMD
      Message(2)= #RPM-1  ;Utility CMD
      Message(3)= param2  ;track
      
    Case #RMB ;read memory blocks
      Message(0)= 14 ;ATMEGA CMD
      Message(2)= #RMB ;Utility CMD
      Message(3)= param2 ;times 256 bytes
      Message(4)= param3 & 255 ;memory start address low
      Message(5)= param3/256   ;memory start address high
      returnlen=param2*256+2
      
  EndSelect
  Message(1)= 8 ;message length
  Message(7)= $AA ;utility CMD termination
  SendMessage(Message(1),returnlen,3)  ; execute utility command
  ProcedureReturn SerBuffer(0)

EndProcedure


Procedure.s GetErrorMessage()

  DOS_Error=#False
  DeviceStatus.s=""
  StatusBarText(0, 0, DeviceStatus)
  If ErrorLevel=0
    payload= IEC_ReceiveString(15,64,2)
    
    If IEC_Status = 64
      For n=0 To payload-1
        ; Debug Str(SerBuffer(n)) +"   "+Chr(SerBuffer(n))
        If SerBuffer(n)>13
          DeviceStatus=DeviceStatus+Chr(SerBuffer(n))
        EndIf
      Next n
      DOS_ErrNum=Val(DeviceStatus)
      Select DOS_ErrNum
          
        Case 0 To 1 ;OK
        Case 73     ;'Power On' or wrong format (<>2A) Message
        Default
          DOS_Error=#True
          AppendLogEntry (DeviceStatus)
      EndSelect
      StatusBarText(0, 0, DeviceStatus) 
    EndIf
  EndIf
 
ProcedureReturn DeviceStatus 

EndProcedure


Procedure StartDrive(drive_app=#READ_TRACK, show_info=#True)
  
  Select DriveTypeNum
    Case #CBM1541, #CBM1570, #CBM1571
      
      Utility(#INIT,drive_app)
      
      If show_info=#True And drive_app=#READ_TRACK
        For n=0 To 20
          stext1.s=stext1+Left(RSet(Str(n),2,"0"),1)
          stext2.s=stext2+Right(Str(n),1)
        Next n
        AppendLogEntry ("Sec:"+stext1)
        AppendLogEntry ("Sec:"+stext2)
        AppendLogEntry (RSet("", 25, "="))
      EndIf
  EndSelect
  
EndProcedure

Procedure Check_6522_Fast_Mode()
  
  Select DeviceSerial_6522_Mode
    Case #FAST
      ProcedureReturn #True
    Case #SLOW
      AppendLogEntry("Not supported without 6522 Fast Serial Driver!") 
      ProcedureReturn #False
  EndSelect
  
EndProcedure

Procedure DumpROM()
  
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  Select DriveTypeNum
    Case #CBM1571, #CBM1581
      pages=128
      start_adr=$8000
    Default
      pages=64
      start_adr=$c000
  EndSelect
           
  File.s=GetFilenameDialog(#True,4,DriveType+"_"+Hex(start_adr)+"_ROM.bin")
  If File="":ProcedureReturn:EndIf
  If CreateFile(0, File) 
    AppendLogEntry ("Memory download $"+Hex(start_adr)+"-$"+Hex(start_adr+256*pages-1))
    Select DriveTypeNum
      Case #CBM1581
        Message(0)= 17 ;ATMEGA CMD
        Message(1)= 6
        Message(2)=(Device & $1F)
        Message(3)=15             ;secondary address
        Message(4)= start_adr/256 ;mem start hi
        Message(5)= pages        ;times 256 bytes
        SendMessage(Message(1),pages*256,4)  ; execute command
      Default
        StartDrive(#READ_MEMORY)
        Utility(#RMB,pages,start_adr)
    EndSelect

    If ErrorLevel=0
      AppendLogEntry("Saving ROM image: "+File)
      For bufptr=0 To pages*256-1
        WriteByte(0,SerBuffer(bufptr))
      Next bufptr
    Else
      AppendLogEntry("Download failed")
    EndIf
    CloseFile(0)  
  Else
    MessageRequester(#APP_NAME, #FILE_ERROR_W+File,$30)
  EndIf  
  
EndProcedure

Procedure DetectDriveType()
 ; get drive types (1541, 1570, 1571, 1581)
 ; set Global: DriveTypeNum, DriveType

  IEC_Open(15,"M-R"+Chr(Val("$40"))+Chr(Val("$FF"))) ;read memory $FF40
  If ErrorLevel=0
    
    IEC_ReceiveString(15)
    
    
    DriveType="UNKNOWN"
    DriveTypeNum=#CBMXXXX
    
    ;Debug SerBuffer(0)
    Select SerBuffer(0)
      Case Val("$D7")
        DriveTypeNum=#CBM1570
        DriveType="1570"
      Case Val("$AC")
        DriveTypeNum=#CBM1571
        DriveType="1571"
      Case Val("$BA")
        DriveTypeNum=#CBM1581
        DriveType="1581"
      Case Val("$AA")
        DriveTypeNum=#CBM1541
        DriveType="1541"
      Case Val("$18")
        DriveTypeNum=#CBM1541
        DriveType="1541-C"
      Case Val("$0F")
        DriveTypeNum=#CBM1541
        DriveType="1541-II"
      Case Val("$85")
        DriveTypeNum=#CBM1541
        DriveType="1541-JIFFY"
      Case Val("$10")
        DriveTypeNum=#CBM1541
        DriveType="1541-SDOS"
    EndSelect
    Select DeviceSerialMode
      Case #FAST
        IEC_SendString(15, "M-W"+Chr(Val("$04"))+Chr(Val("$40"))+Chr(1)+Chr(#T_FAST_CLK-1)) ;6526 FSM:  2us/bit -> 20us/byte -> ca. 50Kbyte/s
      Case #SLOW
        ;check for connection DATA->CB2
        IEC_SendString(15, "M-W"+Chr(Val("$0C"))+Chr(Val("$18"))+Chr(1)+Chr(33)) ;set CB2 independent interrupt flag
        IEC_SendString(15, "M-R"+Chr(Val("$0D"))+Chr(Val("$00")))                ;trigger CB2 and read interrupt flag
        IEC_ReceiveString(15)
        If (SerBuffer(0) & 8)=8
          DriveType+"+"
          DeviceSerial_6522_Mode=#FAST
        Else
          DeviceSerial_6522_Mode=#SLOW
        EndIf
    EndSelect
  EndIf
  
EndProcedure





Procedure.s InitializeDisk(initialize=#True, silent=#True)
; uses byte 3 of BAM for detection of current diskformat
; sets Global: DiskType, DiskID
; inits disk
  

  DiskType = #CBM1541
  msg$="1541 DISK"

  If initialize=#True
    IEC_SendString(15,"I");load BAM
    IEC_Close(15)
    GetErrorMessage()
    IEC_SendString(15, "M-R"+Chr(Val("$12"))+Chr(Val("$100"))+Chr(Val("$02"))) ;read memory $0012 & $0013
    IEC_ReceiveString(15)
    DiskID(1)=SerBuffer(0)
    DiskID(2)=SerBuffer(1)
  EndIf
  Select DriveTypeNum
    Case #CBM1541, #CBM1570
      If ErrorLevel=0 And DOS_Error=#False
       IEC_SendString(15,"M-R"+Chr(3)+Chr(7)) ;read memory $0703: BAM byte 3, 1541/157x BAM
        IEC_ReceiveString(15)
        If SerBuffer(0)=$80
          DiskType = #CBM1571 ;BAM INDICATES 1571 DISK
          msg$="1571 DISK ???"
        EndIf
      EndIf
    Case #CBM1571
      If ErrorLevel=0
        IEC_SendString(15,"M-R"+Chr(Val("$AC"))+Chr(2)) ;read memory $02AC
        IEC_ReceiveString(15)      
        If SerBuffer(0)=71
          DiskType = #CBM1571
          msg$="1571 DISK"
        EndIf
      EndIf
    Case #CBM1581
      DiskType = #CBM1581
      msg$= "1581 DISK"
  EndSelect
  If silent=#False
    AppendLogEntry(msg$)
  EndIf
  
  ProcedureReturn msg$
  
EndProcedure

Procedure GetDirectory()
 
  ClearGadgetItems(ListView_0)
  IEC_Open(0, "$")
  IEC_ReceiveString(0, 2);skip VIC20 basic startadress ($0401) low/high, 2 bytes
  GetErrorMessage()
  If DOS_Error=#False
    payload=IEC_ReceiveString(0, 8000) ;read entire directory 
    If payload>20
      While i<(payload-5) And (SerBuffer(i) | SerBuffer(i+1))<>0 ;end marker is two '00' bytes
        blocks=SerBuffer(i+2)+256*SerBuffer(i+3)
        i = i + 4 : DirLine.s = ""
        Repeat
          If SerBuffer(i) > 31 
            DirLine = DirLine + Chr(SerBuffer(i))
          EndIf
          i = i + 1
        Until SerBuffer(i-1) = 0 Or i = payload ;end of line ?
        AddGadgetItem(ListView_0,-1,Str(blocks) + Space(1) + DirLine)
        If i=payload:Break:EndIf
      Wend
      GetErrorMessage()
      If DOS_Error=#False
        SetGadgetItemText(ListView_0,0,GetGadgetItemText(ListView_0,0)+" ("+InitializeDisk(#False)+")") ;headline
      EndIf
    EndIf
  EndIf
  IEC_Close(0)

EndProcedure

Procedure SendDOS_command()
  
  Title.s="Send DOS command"
  PromtTxt.s = "Enter DOS command:" 
  
  DOS_Command.s=Left(InputRequester(Title,PromtTxt, ""),40)
  If DOS_Command <> ""
    AppendLogEntry("DOS command: "+Chr(34)+DOS_Command+Chr(34))
    IEC_SendString(15,DOS_Command)
    IEC_Close(15) ;wait until DOS command executed
    GetErrorMessage()
  EndIf
  
EndProcedure

Procedure CreateTrack(Track.a, blanktrack=#False,init_18_0=#False)
  
; DOS sector:
; ===========
; Component   Bytes (GCR)   Bytes (non GCR)							
; SYNC          5		      5 -> $FF							
; HEADER       10		      8 -> $08, checksum [], [Sector, Track, ID2, ID1], $0F, $0F
; GAP1          9		      9 -> $55							
; SYNC          5		      5 -> $FF							
; Data        325		    260 -> $07, 256*Data, checksum of Data, $00, $00			
; GAP2*         n		      n -> $55	
; ------------------------------------						
; Sector:     354+n       287+n						
; 
; *GAP2 quantity can range from 4 up to about 20, depending on actual track capacity

  TrackBufPointer=0
  If track=1:SectorCount=0:EndIf

  For Sector.a = 0 To TrackPar(Track)\Sectors-1
    If blanktrack=#False And ImageErrorBytes=#True ;disk errors supported?
      FileSeekTest(0,ImageErrorStart+SectorCount)
      ErrorOnSector=ReadAsciiCharacter(0) & $F
      If ErrorOnSector>1
        AppendLogEntry("Creating error: "+"T"+RSet(Str(track),2,"0")+", S"+RSet(Str(Sector),2,"0")+"> "+GetStatusTxt(ErrorOnSector,#True))
      EndIf
    Else
      ErrorOnSector=0 ;no error support
    EndIf
    If ErrorOnSector=3 ; NO SYNC
      syncbyte=$55
    Else
      syncbyte=$FF
    EndIf
    For n=0 To TrackPar(Track)\HeaderSyncN-1
      TrackBuffer(TrackBufPointer+n)=syncbyte ;SYNC
    Next n
    TrackBufPointer+n
    ;HEADER
    Dim Temp(8)
    Temp(0)=TrackPar(Track)\HeaderID ;HEADER ID
    Temp(1)=Sector ! Track ! DiskID(2) ! DiskID(1) ;HEADER
    Temp(2)=Sector
    Temp(3)=Track
    Temp(4)=DiskID(2)
    Temp(5)=DiskID(1)
    Temp(6)=TrackPar(Track)\HeaderFill1
    Temp(7)=TrackPar(Track)\HeaderFill2 ;Fill1 & Fill2 add 3 GCR bytes $55 to GAP1
  
    Select ErrorOnSector
      Case 2 ;SECTOR NOT FOUND
        Temp(0)=0
      Case 9 ;HEADER BLOCK CHECKSUM ERROR
        Temp(1)=Temp(1)+1
      Case $B ;DISK ID MISMATCH/DISK CHANGE
        Temp(5)=Temp(5)+1
        Temp(1)=Sector ! Track ! DiskID(2) ! Temp(5) ;HEADER
    EndSelect
    EncodeGCR(8)
    For n=0 To TrackPar(Track)\HeaderGapN-1
      TrackBuffer(TrackBufPointer+n)=TrackPar(Track)\HeaderGap ;GAP1
    Next n
    TrackBufPointer+n
    ;DATA
    
    For n=0 To TrackPar(Track)\DataBlockSyncN
      TrackBuffer(TrackBufPointer+n)=syncbyte ;SYNC
    Next n
    TrackBufPointer+n
    Dim Temp(260)
    Temp(0)=TrackPar(Track)\DataBlockID ;data block ID
    checksum.a=0
    If blanktrack=#False
      FileSeekTest(0,TrackPar(Track)\Offset+Sector*256)
      For n=0 To 255
        Temp(1+n)=ReadAsciiCharacter(0) ;DATA
        checksum ! Temp(1+n)
      Next n
    Else
      For n=0 To 255
        Temp(1+n)=0 ;DATA
      Next n
      If init_18_0=#True And Track=18 And Sector=0
        Temp(1+2)=TrackPar(Track)\FormatLayout;'A' 1541 format layout
        checksum=TrackPar(Track)\FormatLayout;
      EndIf
    EndIf
    Temp(1+n)=checksum
    Temp(2+n)=0
    Temp(3+n)=0
    Select ErrorOnSector
      Case 4 ;DATA BLOCK NOT FOUND
        Temp(0)=0
      Case 5 ;DATA BLOCK CHECKSUM ERROR
        Temp(1+n)=Temp(1+n)+1
    EndSelect
    
    EncodeGCR(260)
    
    For n=0 To TrackPar(Track)\InterSectorGapN-1
      TrackBuffer(TrackBufPointer+n)=TrackPar(Track)\InterSectorGap ;GAP2
    Next n
    TrackBufPointer+n
    SectorCount+1
  Next Sector
  
  TrackBuffer(TrackBufPointer)=0;end marker
  
  ProcedureReturn TrackBufPointer+1
 
EndProcedure


Procedure FastFormat()
  
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  Select DriveTypeNum
    Case #CBM1581
      AppendLogEntry (#EXCLUDED_1581)
    Default
      Title.s="Fast Format 35 Tracks (GCR)"
      PromtTxt.s = "Enter [Diskname,ID]:" 
      NameID.s=Left(InputRequester(Title,PromtTxt, "DISK " +FormatDate("%yyyy%mm%dd", Date()) +"," + Chr(Random(25)+65)+ Chr(Random(25)+65)),19)
      If FindString(NameID,",")>0
        dname.s=Left(NameID,FindString(NameID,",")-1)
        AppendLogEntry(Title):AppendLogEntry(Chr(34)+NameID+Chr(34))
        id.s=Left(Trim(Right(NameID,Len(NameID)-FindString(NameID,","))),2)
        DiskID(1)=Asc(Left(id,1)):DiskID(2)=Asc(Right(id,1))
        StartDrive(#WRITE_TRACK)
        If (Utility(#M_R,$1c00) & $10) = 0
          AppendLogEntry(GetStatusTxt(8,#True))
          DOS_Error=#True:ProcedureReturn ;write protect
        EndIf
        If ErrorLevel>0:ProcedureReturn:EndIf
        Utility(#M_W,6,1) :Utility(#M_W,0,$c0);bump
        While Utility(#M_R,0)>128:Wend
        SetTrackParameter()
        For Track=1 To 35
          trkbuflen=CreateTrack(Track,#True,#True)
          CopyMemory(@TrackBuffer(),@Message(3),trkbuflen)
          Message(0)=11
          Message(1)=0
          Message(2)=trkbuflen/256+1 ; pages (256 bytes)
          SendMessage(Message(2)*256+3) ;transfer data to ATMEGA
          Msg.s="Formatting Track: " +Str(Track)
          StatusBarText(0, 0,Msg)
          StatusBarProgress(0,#PROGRESS_FIELD,Track,0,1,35)
          Utility(#T_W,2,Track)
        Next Track
      EndIf
      If Len(dname)>0
        IEC_SendString(15,"N:"+dname) ;write BAM
        IEC_Close(15)
        GetErrorMessage()
        If DOS_ErrNum=73 ;don't mess around with TrackPar(Track)\FormatLayout
          AppendLogEntry("Disk format type error: Type <> 'A'")
        EndIf
        If DOS_Error=#False:GetDirectory():EndIf
      EndIf
  EndSelect
  
EndProcedure

Procedure RPM_Check(n_times)
  
  Msg.s="Drive Spindle Speed; nominal 300 RPM [294 < RPM < 306]"
  
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  Select DriveTypeNum
    Case #CBM1541, #CBM1570, #CBM1571
      If DOS_Error=#False
        AppendLogEntry(Msg)
        StartDrive(#MEASURE_RPM)
        While WaitWindowEvent(1)<>#PB_Event_CloseWindow And ErrorLevel=0 And n_times>0
          Utility(#RPM,18) ;1541: use SYNC; 157X: use INDEX pulse
          If ErrorLevel=0
            If SerBuffer(2)=0 Or SerBuffer(2)>6: AppendLogEntry("Error: RPM Timeout"):Break:EndIf
            spintime.l=(65536*SerBuffer(2)+256*SerBuffer(1)+SerBuffer(0))*(1/#ATMEGA_CLK*#ATMEGA_PRESCALER)
            If spintime_min=0 Or spintime<spintime_min
              spintime_min=spintime
            EndIf
            If spintime_max=0 Or spintime>spintime_max
              spintime_max=spintime
            EndIf
            AppendLogEntry(StrD(60e6/spintime,1))
          EndIf
          n_times -1
        Wend
      Else
        ProcedureReturn
      EndIf
      If spintime_min>0
        AppendLogEntry("RPM min: "+StrD(60e6/spintime_max,1)+"; max: "+StrD(60e6/spintime_min,1))
        ActualDriveSpintime=spintime_min ;ca. 200000us
      Else
        ActualDriveSpintime=#SPIN_TIME
      EndIf
    Case #CBM1581
      AppendLogEntry (#EXCLUDED_1581)
  EndSelect
  GetErrorMessage()
  
EndProcedure

Procedure.f GetTrackInfo()


  If ArraySize(SerBuffer()) >5
    bytesread=SerBuffer(ArraySize(SerBuffer())) *256+SerBuffer(ArraySize(SerBuffer())-1);bytes per timeout
    If bytesread>0
      byte_time=Round(#TIMEOUT/bytesread,#PB_Round_Nearest);[us]
      bitrate.a=Abs((32-byte_time))/2
      actual_capacity=Round(ActualDriveSpintime/#TIMEOUT * bytesread,#PB_Round_Down) ;calc actual track capacity
        For n=0 To actual_capacity
          If n>=ArraySize(SerBuffer()):Break:EndIf
          If (SerBuffer(n) & SerBuffer(n+1))=$FF And SerBuffer(n+2)<>$FF
            synccounter= synccounter+1
            n=n+2
            TrackSum=TrackSum+2*$FF
          EndIf
          TrackSum=TrackSum+SerBuffer(n)
        Next n
    EndIf 
  EndIf
  TrackInfo(0)=synccounter
  TrackInfo(1)=bitrate
  TrackInfo(2)=TrackSum/1000
  TrackInfo(3)=actual_capacity

  ProcedureReturn byte_time
  
EndProcedure

Procedure ProcessTrack(Track.a)

  If DeviceErr=#True:ProcedureReturn #False:EndIf
  If track=1:SectorCount=0:EndIf
  GetTrackInfo()
  ;MaxSec.a = GetSectorsPerTrack(Track,dos)
  MaxSec.a=TrackPar(Track)\Sectors
  
  LoadTrackSuccess.a = #True
  For Sector = 0 To MaxSec - 1
    read_error.a=1 ;<2 --> no error

     ptrImage= TrackPar(Track)\Offset+Sector*256
    ;Debug track ;Hex(ptrImage)
    result=SeekHeader(Track,Sector)

    Select result
      Case 0,1 ;0=no header sync+$08; 1=sync+$08 found but track in header doesn't match current track
        read_error=2 ;SECTOR NOT FOUND
        If TrackInfo(0)<TrackPar(Track)\Sectors*2 Or TrackInfo(0)>256 ;sync count ok?
          read_error=3 ;NO SYNC (assumed due to incorrect sync count) 
        EndIf
      Case 2         
         read_error=9 ;HEADER BLOCK CHECKSUM ERROR
      Case $0F
        read_error=3 ; NO SYNC (entire track)
      Case $FF       ;header ok
        HeaderID1=Temp(5)
        HeaderID2=Temp(4)
        Repeat
          SerBufPointer=SerBufPointer+1
        Until (SerBuffer(SerBufPointer-1)=$ff And SerBuffer(SerBufPointer)<>$ff) Or SerBufPointer>=ArraySize(SerBuffer())
        DecodeGCR(260)
        If Temp(0)=TrackPar(Track)\DataBlockID And SerBufPointer<ArraySize(SerBuffer());data block marker ok?
          chksum.a=0
          For n = 0 To 255
            DiskImage(ptrImage + n) = Temp(1 + n) ;transfer to image
            chksum=chksum ! Temp(1 + n)
          Next n
          chksum=chksum ! Temp(1 + n)
          If chksum<>0 : read_error=5 : EndIf ;DATA BLOCK CHECKSUM ERROR
        Else
          read_error=4 ;DATA BLOCK NOT FOUND
        EndIf
        
        If HeaderID1<>DiskID(1) Or HeaderID2<>DiskID(2)
          read_error=$B ;DISK ID MISMATCH/DISK CHANGE
        EndIf
        
    EndSelect
    If  read_error>1
      LoadTrackSuccess = #False
    EndIf
    errinfo.s=errinfo+Hex(read_error)
   If ImageErrorBytes=#True
     DiskImage(ImageErrorStart+SectorCount)=read_error
   EndIf
   
    SectorCount+1
  Next Sector
  If LoadTrackSuccess = #False :errinfo.s=errinfo+"<!":EndIf
  AppendLogEntry ("T"+RSet(Str(Track),2,"0")+":"+LSet(errinfo,23)+"  SY:"+RSet(Str(TrackInfo(0)),4,"0")+"  BRZ:"+Str(TrackInfo(1)))
  ProcedureReturn LoadTrackSuccess
 
EndProcedure

Procedure.a LoadTrack(Track.a)
  ;Track=36
    ;Track=18
  If Track=0 Or Track>TracksOnDisk Or ErrorLevel>0
    ProcedureReturn #False
  EndIf
 
  Msg.s="Reading Track: "+Str(Track)
  StatusBarText(0, 0,Msg)

  Select DriveTypeNum
    Case #CBM1541, #CBM1570, #CBM1571
      Repeat
        retries=retries+1
        If OnlySide0=#False
          Utility(#T_R,TrackPar(Track)\ReadCapacity,Track) ;side 0/1 logical
          LoadTrackSuccess=ProcessTrack(Track)
        Else
          Utility(#T_R,TrackPar(Track)\ReadCapacity,Track, $80 | TrackPar(Track)\BitRate) ;side 0 physical
          LoadTrackSuccess=ProcessTrack(Track)          
        EndIf
      Until LoadTrackSuccess=#True Or retries=1
      
    Case #CBM1581
      LoadTrackSuccess =#True
      ;40 sectors per track
      For side = 0 To 1
        ;read logical track: "U0",CMD, tr, se, #se, next tr
        Sector = side * 20
        Message(0)=8 ;command
        Message(1)=10;message length
        Message(2)=(Device & $1F)
        Message(3)=15                      ;secondary address
        Message(4)=Asc("U")                ;execute Burst Read
        Message(5)=Asc("0")
        Message(6)=$C0 ;command parameter
        Message(7)=Track
        Message(8)=Sector
        Message(9)=1
        Select SendMessage(10,20 * 256 + 1) ;20 sectors + status byte
          Case 1; error packet? (error payload = 1 byte)
            If (SerBuffer(0) & $8F) > 1 
              LoadTrackSuccess = #False
              AppendLogEntry ("Error on:  Track " +Str(Track) + "; Sector "+Str(Sector)+"; @Adr.: "+Hex(TrackPar(Track)\Offset))
              AppendLogEntry (GetStatusTxt(SerBuffer(0),#True))
            EndIf
          Case 20 * 256 + 1 ;packet ok?
            ptrImage = (Track - 1) * 40 * 256 + 20 * 256 * side ;mem offset
            CopyMemory(@SerBuffer(1),@DiskImage(ptrImage),5120)
;             For n = 1 To 5120                                   ;copy 20*256 bytes from serbuf to image
;               DiskImage(ptrImage + n - 1) = SerBuffer(n)
;             Next n
          Default
            AppendLogEntry("Data packet has wrong size"); for log
            ProcedureReturn #False
        EndSelect
      Next side
  EndSelect
  
ProcedureReturn LoadTrackSuccess

EndProcedure


Procedure DumpTrack()
  
  If DriveTypeNum=#CBM1581:AppendLogEntry(#EXCLUDED_1581):ProcedureReturn:EndIf
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  OnlySide0=#False
  DeviceErr=#False
  ClearGadgetItems(Editor_1)
  input$=InputRequester(#APP_NAME, "Read track #; (append 'p' for physical; e.g. 36p)","18")
  If FindString(UCase(input$),"P") ;physical?
    OnlySide0=#True
  EndIf
  track=Val(input$):If track=0:ProcedureReturn:EndIf
  AppendLogEntry ("Reading sectors on track "+RSet(Str(track),2,"0"))
  
  InitializeDisk()
  StartDrive()
  If ErrorLevel>0:ProcedureReturn:EndIf
  GetMaxTrackByDriveType(#True) ;init image
  
  LoadTrack(track)
  AppendLogEntry ("")
  ClearGadgetItems(Editor_1)
  For sector=0 To 20
    result$="":temparrayptr=0
    If SeekHeader(track,sector)=$FF
      SerBufPointer-10; header start
      For n=0 To 37
        DecodeGCR(8):temparrayptr=0 ; 8 byte chunks
        If (SerBufPointer)>=ArraySize(SerBuffer()):Break:EndIf ;seek next header
        For n_gcr=0 To 9
          If SerBuffer(SerBufPointer-10+n_gcr)=$FF 
            result$=result$+" >>" ;display sync
            If   SerBuffer(SerBufPointer-10+n_gcr+1)<>$FF
              SerBufPointer=SerBufPointer-10+n_gcr+1 ;resync
              Break
            EndIf
          Else
            If n_gcr<8
              result$=result$+" "+RSet(Hex(Temp(temparrayptr)),2,"0")
              temparrayptr+1
            EndIf
          EndIf
        Next n_gcr
      Next n
    Else
      result$=GetStatusTxt(2,#True)
    EndIf
    AppendLogEntry("S"+RSet(Str(sector),2,"0")+": "+result$)
    
  Next sector
  AppendLogEntry("Nominal track capacity: "+CalcTrackCapacity(TrackInfo(1))+" @ 300.0 RPM")
  AppendLogEntry("Actual  track capacity: "+Str(TrackInfo(3)))
  
  disp$="":offs=0
  For n=1 To ArraySize(SerBuffer())
    disp$=disp$+RSet(Hex(SerBuffer(n-1)),2,"0")+" "
    If  n%16 =0
      disp$="$"+RSet(Hex(offs),4,"0")+": "+disp$
      For pointer= n-16 To n-1
        If pointer<ArraySize(SerBuffer())
          If (SerBuffer(pointer)=$ff And SerBuffer(pointer+1)=$52)
            SerBufPointer=pointer+1:DecodeGCR(4)
            disp$=disp$+"> T: "+RSet(Str(Temp(3)),2,"0")+"; S: "+RSet(Str(Temp(2)),2,"0")
            Break
          EndIf
        EndIf
      Next pointer
      AddGadgetItem(Editor_1,-1,disp$)
      disp$="":offs+16
    EndIf
  Next n
  
  If (TrackInfo(1) << 5) <> TrackPar(Track)\BitRate
    AppendLogEntry("Bitrate zone (BRZ) mismatch!")
    AppendLogEntry("Nominal BRZ: "+Str(TrackPar(Track)\BitRate >> 5))
    AppendLogEntry("Track   BRZ: "+Str(TrackInfo(1)))
  EndIf
  
  OnlySide0=#False
  GetErrorMessage()
  
EndProcedure

Procedure GetPrgImage()
  
  SelEntry.s = GetGadgetText(ListView_0)
  FNameStart = FindString(SelEntry, Chr(34))
  FNameEnd = FindString(SelEntry, Chr(34),FNameStart + 1)
  If FNameStart < 5 Or FNameEnd < 1
    AppendLogEntry ("SELECTION NOT VALID!")
  Else
    PRG_Name.s = Mid(SelEntry, FNameStart + 1, FNameEnd - FNameStart - 1)
    Blocks=Val(GetGadgetText(ListView_0))
  EndIf
  SetGadgetState(ListView_0,-1)
  
  If PRG_Name<>""
    AppendLogEntry("Open "+DriveType+" file: "+Chr(34)+PRG_Name+Chr(34)+" [PRG]")
    IEC_Open(0,PRG_Name)
    GetErrorMessage()
    IEC_Close(0)
    If DOS_Error=#True Or ErrorLevel>0:ProcedureReturn:EndIf
    
    File.s=PRG_Name
    If CheckFilename(PRG_Name)=0:File="":EndIf ;valid MS-DOS file name?
    File=GetFilenameDialog(#True,1,File)
    If File<>""
      If CreateFile(0, File) 
        IEC_Open(0,PRG_Name)
        While ErrorLevel = 0 And IEC_Status=0 And Lof(0)<800000
          WriteData(0,@SerBuffer(),IEC_ReceiveString(0, #BytesSectorPayload)):BlockCount +;read one block
          StatusBarProgress(0,#PROGRESS_FIELD,BlockCount,0,1,Blocks)
        Wend
        prg_size=Lof(0)
        AppendLogEntry("PRG image size: $"+Hex(prg_size)+" bytes")
        AppendLogEntry("Blocks: "+Str(Round(prg_size/#BytesSectorPayload,#PB_Round_Up)))
        If Lof(0)>2
          FileSeek(0,0):StartLow=ReadAsciiCharacter(0):StartHigh=ReadAsciiCharacter(0)
          AppendLogEntry("Start address: $"+Hex(StartHigh*256+StartLow))
          AppendLogEntry("End   address: $"+Hex(StartHigh*256+StartLow+(prg_size-1)-2))
        EndIf
        GetErrorMessage()
        IEC_Close(0)
        CloseFile(0)                         
      Else
        MessageRequester(#APP_NAME, #FILE_ERROR_W+File,$30)
      EndIf
    EndIf
  EndIf


EndProcedure


Procedure.s GetDiskImage(verify.a=#False, dos.a=#True)
  ;*** reads disk on a track basis For drives 1541/1570/1571/1581***
  
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  
  If GetMenuItemState(0,#MENU_ENABLE_40TRACKS)=#False
    OnlySide0=#False
  Else
    OnlySide0=#True
  EndIf
  
  If GetMenuItemState(0,#MENU_ENABLE_ERRORS)=#False
    ImageErrorBytes=#False
  Else
    ImageErrorBytes=#True
  EndIf
  
    
DeviceErr=#False
InitializeDisk()
MaxTrack = GetMaxTrackByDriveType() ;init image

If DiskType=#CBM1571 And DriveTypeNum<>#CBM1571
  MessageRequester("Caution!","Can't read all tracks on "+DriveType,#PB_MessageRequester_Ok)
EndIf
AppendLogEntry ("Reading "+Str(TracksOnDisk)+" tracks")

StartDrive()

For Track = 1 To TracksOnDisk
  StatusBarProgress(0,#PROGRESS_FIELD,Track,0,1,TracksOnDisk)
  LoadTrack(Track)

Next Track

Select DriveTypeNum
  Case #CBM1541, #CBM1570, #CBM1571
    Utility(#T_R,1,18)
EndSelect

GetErrorMessage()


If verify=#False And ErrorLevel=0
  File.s=GetFilenameDialog(#True)
  If File<>""
    If CreateFile(0, File)   
      WriteData(0, @DiskImage(0), ImageSize)
      CloseFile(0)                         
    Else
      MessageRequester(#APP_NAME,#FILE_ERROR_W,$30)
    EndIf
  EndIf
EndIf
ProcedureReturn "OK"

EndProcedure

Procedure RestorePrgImage(File.s)
  
  BlocksFree=  Val(GetGadgetItemText(ListView_0,CountGadgetItems(ListView_0)-1)) ;free blocks
  If FileSize(File)> BlocksFree * #BytesSectorPayload
    AppendLogEntry("Can't restore: "+Str(Int(FileSize(File) / #BytesSectorPayload) + 1)+"PRG BLOCKS > 'BLOCKS FREE' "+Str(BlocksFree))
  Else
    If ReadFile(0, File)
      PRG_Name.s=UCase(GetFilePart(File))
      If FindString(PRG_Name,".")<>0
        PRG_Name=Left(PRG_Name,FindString(PRG_Name,".")-1)
      EndIf
      AppendLogEntry("Restoring "+Chr(34)+PRG_Name+Chr(34)+" [PRG]")
      PRG_Name = "@0:"+Left(PRG_Name,16) 
      IEC_Open(1,PRG_Name)
      GetErrorMessage()
      If DOS_Error=#False And ErrorLevel=0
        AppendLogEntry( "Writing "+Str(Int(Lof(0) / #BytesSectorPayload) + 1) + " blocks; "+Str(Lof(0))+ " bytes")
        IEC_Status=0
        While Eof(0) = 0 And IEC_Status=0
          IEC_SendMessageString( 1, ReadData(0,@message(4),250)); length adapted to ATMEGA buffer
          StatusBarProgress(0,#PROGRESS_FIELD,Loc(0),#PB_StatusBar_BorderLess,1,Lof(0))
        Wend
        IEC_Close (1)
        GetErrorMessage()
      EndIf
      CloseFile(0)
    Else
      MessageRequester(#APP_NAME, #FILE_ERROR_R+File, 0)
    EndIf 
  EndIf

EndProcedure

Procedure RestoreG64Image(File.s)
  
  rpm.f=60e6/ActualDriveSpintime
  ;rpm.f=300.5
  #RPM_MARGIN=0 ;in bytes
  #MAX_TRACK=40
  
  If ReadFile(0, File)  
    InitializeDisk()
    DOS_Error=#False
    StartDrive(#WRITE_TRACK)
    If (Utility(#M_R,$1c00) & $10) = 0;write protect?
      AppendLogEntry(GetStatusTxt(8,#True))
      DOS_Error=#True
    EndIf
    If DOS_Error=#True Or ErrorLevel>0:CloseFile(0):ProcedureReturn:EndIf ;write protect?
    G64_id.s=ReadString(0,#PB_Ascii,8)
    If G64_id<>"GCR-1541":AppendLogEntry("G64 image not valid"): CloseFile(0):ProcedureReturn:EndIf
    AppendLogEntry ("Restoring file: "+Chr(34)+GetFilePart(File)+Chr(34))
    AppendLogEntry("G64 version: "+Str(ReadAsciiCharacter(0)))
    AppendLogEntry("G64 tracks: "+Str(ReadAsciiCharacter(0)))
    AppendLogEntry("G64 track size max.: $"+Hex(ReadAsciiCharacter(0)+$100*ReadAsciiCharacter(0)))
    img_ptr_start=$C
    img_speed_start=$15C
    disp$="track"+RSet("offset",8," ")+RSet("cap",6," ")+RSet("RPM",8," ")
    disp$=disp$+RSet("BR",5," ")+RSet("drive cap",12," ")+RSet("drive RPM",12," ")
    AppendLogEntry(disp$)
    AppendLogEntry(RSet("",Len(disp$),"="))
    For track= 1 To #MAX_TRACK
      foundzero=#False
      img_ptr_offset=img_ptr_start+(track-1)*8:FileSeekTest(0,img_ptr_offset)
      img_track_offset=ReadAsciiCharacter(0)+$100*ReadAsciiCharacter(0)+$10000*ReadAsciiCharacter(0)+$1000000*ReadAsciiCharacter(0)
      img_speed_offset=img_speed_start+(track-1)*8:FileSeekTest(0,img_speed_offset):bitrate_zone=ReadAsciiCharacter(0)
      If img_track_offset>0 
        FileSeekTest(0,img_track_offset)
        img_tracksize=ReadAsciiCharacter(0)+$100*ReadAsciiCharacter(0): tracksize= img_tracksize
        If img_tracksize>CalcTrackCapacity(bitrate_zone,rpm):tracksize=CalcTrackCapacity(bitrate_zone,rpm)-#RPM_MARGIN:EndIf
        img_rpm.f=16e6/4/(16-bitrate_zone)/8*60/img_tracksize
        disp$=RSet(Str(track),2,"0")+"     "+RSet(Hex(img_track_offset),6,"0")+RSet(Hex(img_tracksize),6," ")+RSet(StrF(img_rpm,1),8," ")
        disp$=disp$+RSet(Str(bitrate_zone),5," ")+RSet(Hex(tracksize),12," ")+RSet(StrF(rpm,1),12," ")
        For n=0 To tracksize-1
          TrackBuffer(n)=ReadAsciiCharacter(0)
          If TrackBuffer(n)=0:foundzero=#True:Break:EndIf
        Next n
      EndIf

      If foundzero=#True Or img_track_offset=0 Or img_tracksize=0
        AppendLogEntry(RSet(Str(track),2,"0")+"  not restored; '00'-byte found @file: $"+Hex(Loc(0)))
      Else
        AppendLogEntry(disp$)
        TrackBuffer(tracksize)=0 ;end of track marker
        CopyMemory(@TrackBuffer(),@Message(3),tracksize+1)
        Message(0)=11
        Message(1)=0
        Message(2)=(tracksize+1)/256+1 ; pages (256 bytes)
        SendMessage(Message(2)*256+3) ;transfer data to ATMEGA
        Msg.s="Writing Track: " +Str(track)
        StatusBarText(0, 0,Msg)
        StatusBarProgress(0,#PROGRESS_FIELD,Track,#PB_StatusBar_BorderLess,1,#MAX_TRACK)
        Utility(#T_W,2,track,(bitrate_zone << 5)|$80)
      EndIf
      
    Next track
    CloseFile(0)
    InitializeDisk()
  Else
    MessageRequester(#APP_NAME, #FILE_ERROR_R+File, 0)
  EndIf
  
EndProcedure

Procedure RestoreDiskImage1581(File.s)
  
MaxTrack = GetMaxTrackByFileLen(FileSize(File))
If MaxTrack>0
  If ReadFile(0, File)
    
    Select MessageRequester("Resore Image","Format DISK ?",#PB_MessageRequester_YesNoCancel  | #PB_MessageRequester_Warning)
      Case #PB_MessageRequester_Yes ; format 1581 disk prior to restore data
        ; U0 command used here due to bug in DOS NEW command
        ; DOS NEW command works with a drive poke 149,128 setting the "track cache is empty" flag
        ; If this flag isn't set, the directory track may hold the previous content, except sector 0 & 1!
        
        Message(4)=Asc("U") ;execute FORMAT
        Message(5)=Asc("0")
        Message(6)=6;command parameter
        AppendLogEntry("Formatting 80 tracks")
        IEC_SendMessageString(15,3)
        GetErrorMessage()
      Case #PB_MessageRequester_Cancel
        CloseFile(0):ProcedureReturn
    EndSelect
    
    If DOS_Error=#True Or ErrorLevel>0:CloseFile(0):ProcedureReturn:EndIf ;write protect?
    AppendLogEntry ("Restoring from file: "+Chr(34)+GetFilePart(File)+Chr(34))
    
    For Track = 1 To MaxTrack
      StatusBarProgress(0,#PROGRESS_FIELD,Track,#PB_StatusBar_BorderLess,1,MaxTrack)
      If DeviceErr=#True:CloseFile(0):ProcedureReturn:EndIf 
      StatusBarText(0, 0,"Writing Track: " +Str(Track))
      FileSeekTest(0,TrackPar(Track)\Offset)
      result.a=0
      For n=0 To TrackPar(Track)\Sectors*256-1
        Message(3+n)=ReadAsciiCharacter(0)
        result=result|Message(3+n)
      Next n
      If result <> 0 ;skip empty tracks (40 x 256 x 00h)
        Message(0)=11
        Message(1)=0
        Message(2)=40 ;40 x 256 bytes
        SendMessage(40*256+3) ;transfer track data to ATMEGA   
        Message(0)=9          ;command
        Message(1)=10         ;message length
        Message(2)=Device
        Message(3)=15 ;secondary address
        Message(4)=Asc("U") ;execute Burst Write
        Message(5)=Asc("0")
        Message(6)=$C2 ;command parameter
        Message(7)=Track
        Message(8)=0;Sector
        Message(9)=40
        SendMessage(10,16,5)
        burst_status=SerBuffer(0) & $8F
        If (burst_status) > 1 
          AppendLogEntry ("Track " +Str(Track)+": "+GetStatusTxt(SerBuffer(0),#True))
          If burst_status=8 :Break:EndIf ; write protect?
        Else
          tracks_restored.a+1
        EndIf
      EndIf
      If ErrorLevel>0:CloseFile(0):ProcedureReturn:EndIf
    Next Track
    AppendLogEntry ("Tracks restored: " +Str(tracks_restored))
    CloseFile(0)
    GetErrorMessage()
  Else
    MessageRequester(#APP_NAME, #FILE_ERROR_R+File, 0)
  EndIf
EndIf

EndProcedure

Procedure RestoreDiskImage15xx(File.s)
;*** restores image to disk on track basis for drives 1541/157x ***
  physical.a=#False
MaxTrack = GetMaxTrackByFileLen(FileSize(File))

If MaxTrack>0
  If ReadFile(0, File)  
    InitializeDisk()
    DOS_Error=#False
    StartDrive(#WRITE_TRACK)
    If (Utility(#M_R,$1c00) & $10) = 0;write protect?
      AppendLogEntry(GetStatusTxt(8,#True))
      DOS_Error=#True
    EndIf
    FileSeek(0,TrackPar(18)\Offset+162)
    DiskID(1)=ReadAsciiCharacter(0)                    ;disk ID1
    DiskID(2)=ReadAsciiCharacter(0)                    ;disk ID2 
    
    If DOS_Error=#True Or ErrorLevel>0:CloseFile(0):ProcedureReturn:EndIf ;write protect?
    AppendLogEntry ("Restoring from file: "+Chr(34)+GetFilePart(File)+Chr(34)+"; "+Str(MaxTrack)+" Tracks")
    
    For Track = 1 To MaxTrack
      trkbuflen=CreateTrack(Track)
      If trkbuflen>1
        CopyMemory(@TrackBuffer(),@Message(3),trkbuflen)
        Message(0)=11
        Message(1)=0
        Message(2)=trkbuflen/256+1 ; pages (256 bytes)
        SendMessage(Message(2)*256+3) ;transfer data to ATMEGA
        Msg.s="Writing Track: " +Str(Track)
        StatusBarText(0, 0,Msg)
        StatusBarProgress(0,#PROGRESS_FIELD,Track,#PB_StatusBar_BorderLess,1,MaxTrack)
        If OnlySide0=#False
          Utility(#T_W,2,Track)    ;side 0/1 logical
        Else
          Utility(#T_W,2,Track,TrackPar(Track)\BitRate|$80)
        EndIf
      EndIf
    Next Track
    CloseFile(0)
    InitializeDisk()
  Else
    MessageRequester(#APP_NAME, #FILE_ERROR_R+File, 0)
  EndIf
EndIf

EndProcedure



Procedure RestoreImage()
  
  File.s=GetFilenameDialog()
  If File="":ProcedureReturn:EndIf
  
  Select UCase(GetExtensionPart(File))
    Case "PRG"
      RestorePrgImage(File)
    Case "G64"
      Select DriveTypeNum
        Case #CBM1541
          If Check_6522_Fast_Mode():RestoreG64Image(File):EndIf
        Case #CBM1570, #CBM1571
          RestoreG64Image(File)
        Case #CBM1581
          AppendLogEntry (#EXCLUDED_1581)
      EndSelect
    Default
      Select DriveTypeNum
        Case #CBM1541
          If Check_6522_Fast_Mode():RestoreDiskImage15xx(File):EndIf
        Case #CBM1570, #CBM1571
          RestoreDiskImage15xx(File)
        Case #CBM1581
          RestoreDiskImage1581(File)
      EndSelect
  EndSelect
  
EndProcedure


Procedure VerifyDiskImage(File.s)
  
  MaxTrack.a = GetMaxTrackByFileLen(FileSize(File))
  
  If MaxTrack=0
    MessageRequester(#APP_NAME,"File size does not match disk capacity.")
    ProcedureReturn  
  Else
    If ReadFile(0, File)
      AppendLogEntry ("Verifying "+Str(MaxTrack)+" tracks")
      StartDrive()
      For Track.a = 1 To MaxTrack
        StatusBarProgress(0,#PROGRESS_FIELD,Track,0,1,MaxTrack)
        LoadTrack(Track)
        If ErrorLevel>0:CloseFile(0):ProcedureReturn:EndIf
        For Sector.a = 0 To TrackPar(Track)\Sectors - 1
          SectorOffset=TrackPar(Track)\Offset+Sector*256
          For n = 0 To 255
            filebyte.a=ReadAsciiCharacter(0)
            If DiskImage(SectorOffset + n) <> filebyte
              AppendLogEntry ("Failed track: "+ Str(Track)+", sector: "+ Str(Sector)+", offset: $"+Hex((SectorOffset + n) & 255))
              AppendLogEntry ("File offset: 0x" + Hex(SectorOffset + n))
              AppendLogEntry ("Disk: 0x" + Hex(DiskImage(SectorOffset + n)) + " <> File: 0x" + Hex(filebyte))
              MessageRequester(#APP_NAME, "Verify failed!",#PB_MessageRequester_Ok|$30)
              StatusBarProgress(0,#PROGRESS_FIELD,MaxTrack,0,1,MaxTrack)
              GetErrorMessage()
              CloseFile(0)
              ProcedureReturn
            EndIf
          Next n
        Next Sector
      Next Track
      CloseFile(0)
      AppendLogEntry ("Verify OK")
    Else
      MessageRequester(#APP_NAME, #FILE_ERROR_R+File, 0)
    EndIf
  EndIf

   
EndProcedure

Procedure VerifyImage()
  
  If DriveTypeNum=#CBM1541 And Check_6522_Fast_Mode()=#False:ProcedureReturn:EndIf
  VerifySuccess=#True
  InitializeDisk()
  
  If ErrorLevel>0:ProcedureReturn:EndIf
  
  If DriveTypeNum=#CBM1571 And DiskType=#CBM1571
    File.s=GetFilenameDialog(#False,1)
  Else
    File.s=GetFilenameDialog()
  EndIf
  
  If File="":ProcedureReturn:EndIf
  
  If UCase(GetExtensionPart(File))="PRG" ;verify only one PRG on disk?
    AppendLogEntry( "PRG verify is not supported")
  Else
    VerifyDiskImage(File) ;verify complete disk
  EndIf
  
EndProcedure


Procedure ToolBarClick(ToolbarButton)
  

  DetectDriveType()
  
  
  ComboItem=GetGadgetState(Combo_0)
  If FindString( GetGadgetItemText(Combo_0,ComboItem),DriveType)=0
    SetGadgetItemText(Combo_0,ComboItem,Str(Device)+": "+DriveType);drive type has changed
    SetGadgetText(Combo_0,GetGadgetItemText(Combo_0,ComboItem))
  EndIf

  DisableToolBarButton(0,#MENU_DIRECTORY,1)
  DisableToolBarButton(0,#MENU_CREATE_IMAGE,1)
  DisableToolBarButton(0,#MENU_RESTORE_IMAGE,1)
  DisableToolBarButton(0,#MENU_VERIFY_IMAGE,1)
  DisableToolBarButton(0,#MENU_SEND_DOS_COMMAND,1)
 
  If ErrorLevel=0
    DisableToolBarButton(0,ToolbarButton,0)
    Select ToolbarButton
      Case #MENU_DIRECTORY ;Directory
        GetDirectory()
      Case #MENU_CREATE_IMAGE ;Create image file Dxx, PRG
          GetDirectory()
          GetDiskImage()
      Case #MENU_RESTORE_IMAGE ;Restore image file Dxx, PRG to CBM Disk Drive
          GetDirectory()
          RestoreImage()
          If DOS_Error=#False
            GetDirectory()
        EndIf
      Case #MENU_VERIFY_IMAGE
        VerifyImage()
      Case #MENU_SEND_DOS_COMMAND 
        SendDOS_command()
      Case ListView_0 ;PRG Image
        GetPrgImage()
      Case #MENU_FASTFORMAT
        FastFormat()
      Case #MENU_RPM_CHECK
        RPM_Check(5)
      Case #MENU_RPM_ADJUST
        RPM_Check(500)
      Case #MENU_DUMP_ROM
        DumpROM()
      Case #MENU_DUMP_TRACK
        DumpTrack()
      Case #MENU_CONVERT_GCR
        Convert_GCR_HEX()
      Case #MENU_CONVERT_HEX
        Convert_HEX_GCR()
      Case #MENU_ENABLE_40TRACKS
        SetMenuItemState(0, #MENU_ENABLE_40TRACKS, GetMenuItemState(0,#MENU_ENABLE_40TRACKS)!1)
        displ$="40 tracks enabled"
        If GetMenuItemState(0,#MENU_ENABLE_40TRACKS)=#False
          displ$=ReplaceString(displ$,"enabled","disabled")
        EndIf
        AppendLogEntry(displ$)
      Case #MENU_ENABLE_ERRORS
        SetMenuItemState(0, #MENU_ENABLE_ERRORS, GetMenuItemState(0,#MENU_ENABLE_ERRORS)!1)
        displ$="Image errors enabled"
        If GetMenuItemState(0,#MENU_ENABLE_ERRORS)=#False
          displ$=ReplaceString(displ$,"enabled","disabled")
        EndIf
        AppendLogEntry(displ$)          
      Case #MENU_ERROR_INFO
        AppendLogEntry("DOS low level errors for current device:")
        For n=0 To 15:AppendLogEntry("#"+Hex(n)+": "+GetStatusTxt(n,#True)):Next n
      Case #MENU_ABOUT
        MessageRequester(#APP_NAME,#APP_VERSION+#CRLF$+"Built: "+FormatDate("%dd.%mm.%yyyy",#APP_BUILT)+"; PB"+#PB_Compiler_Version+#CRLF$+#CRLF$+#APP_BY)
      Case #MENU_QUIT
        End
    EndSelect
  EndIf
  
  StatusBarProgress(0,#PROGRESS_FIELD,0)
  If ErrorLevel=0
    AppendLogEntry ("-- done --")
  Else
    AppendLogEntry ("-- aborted --")
  EndIf
  
  SetToolBarButtonState(0,ToolbarButton,0)
  DisableToolBarButton(0,#MENU_DIRECTORY,0)
  DisableToolBarButton(0,#MENU_CREATE_IMAGE,0)
  DisableToolBarButton(0,#MENU_RESTORE_IMAGE,0)
  DisableToolBarButton(0,#MENU_VERIFY_IMAGE,0)
  DisableToolBarButton(0,#MENU_SEND_DOS_COMMAND,0)

EndProcedure

 
Procedure ScanComPorts()
  
  If IsSerialPort(0):CloseSerialPort(0):EndIf
  
  For n=0 To #MAXCOMPORTS
    
    ComPort.s="COM"+Str(n)
    
    If OpenSerialPort(0, ComPort, 460800, #PB_SerialPort_NoParity, 8, 1, #PB_SerialPort_NoHandshake, #InBufSize, #OutBufSize)
      
      
      SetSerialPortStatus(0,#PB_SerialPort_TXD,1)
      Delay(1)
      SetSerialPortStatus(0,#PB_SerialPort_TXD,0)
      Delay(1)
      SetSerialPortStatus(0,#PB_SerialPort_TXD,1)
      Delay(1)
      SetSerialPortStatus(0,#PB_SerialPort_TXD,0)
      Delay(40)
      
      If AvailableSerialPortInput(0)>1
        
        While AvailableSerialPortInput(0)<>0
          
          ReadSerialPortData(0, @SerBuf.s{1}, 1)
          If Asc(SerBuf)<>0
            SerResponse.s =SerResponse.s + SerBuf
          EndIf
        Wend
       ; Debug "COM:"+Str(n)+"  Resp.-Len: "+Str(Len(SerResponse))+"  Resp: "+SerResponse
        If FindString(SerResponse.s , #PWR_ON_MSG,1)>0
          AppendLogEntry(#PWR_ON_MSG + " found @ "+ComPort)
          ProcedureReturn #True
        EndIf 
      EndIf
      CloseSerialPort(0)
    EndIf
  Next n
  ProcedureReturn #False

EndProcedure

Procedure Scan()
  
  Repeat 
    Device=0
    ErrorLevel=0
    SetGadgetState(Button_0 ,0) ;RESET button
    ClearGadgetItems(ListView_0)
    ClearGadgetItems(Combo_0)
    ClearGadgetItems(Editor_0)
    ClearGadgetItems(Editor_1)
    WaitWindowEvent(10)
    
    If ScanComPorts()=#False
      MessageRequester(#APP_NAME, #PWR_ON_MSG+" hardware not present!")
      End
    EndIf
    msg.s="RESET IEC Bus"
    AppendLogEntry(msg)
    StatusBarText(0, 0,msg)
    Message(0)=255:Message(1)=2
    SendMessage (2,0,4); IEC RESET
    If ErrorLevel=0 And IEC_Status=0
      For Device=#START_DEVICE To #END_DEVICE
        DetectDriveType()
        If ErrorLevel>=#ERR_ATMEGA:ClearGadgetItems(Combo_0):Break:EndIf
        If GetStatusTxt(IEC_Status)="OK"
          AppendLogEntry("Drive #"+Str(Device)+" present: "+DriveType)
          AddGadgetItem(Combo_0,-1, Str(Device)+": "+DriveType)
        EndIf
      Next Device
      SetGadgetText(Combo_0,GetGadgetItemText(Combo_0,0)) ;select lowest device no#
      
      Device=Val(GetGadgetItemText(Combo_0,0))
      If Device>0
        ErrorLevel=0
        GetErrorMessage()
      EndIf
    ElseIf IEC_Status=255
      AppendLogEntry("Connect and power on all CBM Disk Drives")
    EndIf 
    
    
    If CountGadgetItems(Combo_0) >0
      DisableGadget(Combo_0,0)
    Else
      DisableGadget(Combo_0,1)
      For n=1 To 100
        If WaitWindowEvent(15)=#PB_Event_CloseWindow:End:EndIf
      Next n
    EndIf

  Until ErrorLevel<#ERR_ATMEGA And CountGadgetItems(Combo_0)>0

EndProcedure


  
Procedure WindowEventHandler()
  
  Select EventGadget()
    Case 0
      newwidth=WindowWidth(Window_0, #PB_Window_InnerCoordinate)-10
      newheight=WindowHeight(Window_0, #PB_Window_InnerCoordinate)
      ResizeGadget(Panel_0, #PB_Ignore, #PB_Ignore,newwidth,newheight-ToolBarHeight(0)-StatusBarHeight(0)-#frame0h-40)
      ResizeGadget(Splitter_0, #PB_Ignore, #PB_Ignore,GetGadgetAttribute(Panel_0,#PB_Panel_ItemWidth),GetGadgetAttribute(Panel_0,#PB_Panel_ItemHeight))
      ResizeGadget(Frame3D_0, #PB_Ignore, #PB_Ignore,newwidth,#PB_Ignore)
      ResizeGadget(Editor_1, #PB_Ignore, #PB_Ignore,GetGadgetAttribute(Panel_0,#PB_Panel_ItemWidth),GetGadgetAttribute(Panel_0,#PB_Panel_ItemHeight))
  EndSelect 
  
EndProcedure

  
;==================================================================================================

InitWindow_0()
BindEvent(#PB_Event_SizeWindow,@WindowEventHandler(),Window_0)
DisableGadget(Combo_0,1)

Restore GCR_table
For x=0 To 31
  Read.a GCR2Bin(x)
Next x
Restore GCR_table1
For x=0 To 15
  Read.a Bin2GCR(x)
Next x

Repeat
  If ErrorLevel>=#ERR_ATMEGA Or CountGadgetItems(Combo_0)=0
    Scan()
    AppendLogEntry("Welcome "+#APP_NAME+" user")
    While WindowEvent()<>0
      WaitWindowEvent(1)
    Wend
    
  EndIf
  
  ErrorLevel=0
  Event = WaitWindowEvent(1)
  Select Event
    Case #PB_Event_Menu
      ToolBarClick(EventMenu())
      
    Case #PB_Event_Gadget
      DisableGadget(Combo_0,1)
      Select EventGadget()
        Case Button_0 ;RESET IEC-Bus
          SetGadgetState(Button_0 ,0)
          ErrorLevel=#ERR_CANCEL
        Case ListView_0
          If EventType() =#PB_EventType_LeftDoubleClick
            ToolBarClick(EventGadget())
          EndIf
        Case Combo_0 ;change Device
          ClearGadgetItems(ListView_0)
          Device=Val(GetGadgetText(Combo_0))
          IEC_Close(15)
          AppendLogEntry("Device "+GetGadgetText(Combo_0)+" Drive selected")
          DetectDriveType()
          GetErrorMessage()
          ActualDriveSpintime=#SPIN_TIME
      EndSelect
      DisableGadget(Combo_0,0)
  EndSelect
  
  
Until Event = #PB_Event_CloseWindow




; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 2168
; FirstLine = 2143
; Folding = ---------
; EnableXP
; UseIcon = floppy.ico
; Executable = FLOPPYmate.exe